module hash;

template Hash(T) {
}

private import std.string;

template digestStringT(T) {
	char[] digestStringT(T d) {
		char[] result;

		if (d.length != 0) {
			typeof(d[0]) u;
			uint sz = u.sizeof*2;
			uint ndigits = 0;

			result = new char[sz*d.length];
			for(int i = d.length-1; i >= 0; i--) {
				u = d[i];
				for(; u; u /= 16) {
					result[result.length-1-ndigits] = hexdigits[u & 15];
					ndigits++;
				}
				for(; ndigits < (d.length-i)*sz; ndigits++)
					result[result.length-1-ndigits] = '0';
			}
		}

		return result;
	}
}
